import java.io.*;
import java.net.*;
import java.util.concurrent.*;

public class BlockingServer {
  public static void main(String... args)
      throws IOException {
    ExecutorService pool = Executors.newCachedThreadPool();
    ServerSocket ss = new ServerSocket(8080);
    while (true) {
      Socket s = ss.accept(); // nie null
      pool.submit(() -> handle(s));
    }
  }

  private static void handle(Socket s) {
    try (InputStream in = s.getInputStream();
         OutputStream out = s.getOutputStream();) {
      int data;
      while((data = in.read()) != -1) {
        out.write(Util.hokuspokus(data));
      }
    } catch (IOException e) {
      System.err.println(e);
    }
  }

}
