import java.io.*;
import java.net.*;
import java.nio.*;
import java.nio.channels.*;
import java.util.*;

public class NonblockingIOPollingServer {
  public static void main(String... args)
      throws IOException {
    ServerSocketChannel ssc = ServerSocketChannel.open();
    ssc.bind(new InetSocketAddress("localhost", 8080));
    ssc.configureBlocking(false);
    Collection<SocketChannel> sockets = new ArrayList<>();
    ByteBuffer buffer = ByteBuffer.allocateDirect(80);
    while(true) {
      SocketChannel newSocket = ssc.accept();
      if (newSocket != null) {
        newSocket.configureBlocking(false);
        System.out.println("Connected to " + newSocket);
        sockets.add(newSocket);
      }
      for (Iterator<SocketChannel> it =
               sockets.iterator(); it.hasNext(); ) {
        SocketChannel socket = it.next();
        buffer.clear();
        int bytesRead = socket.read(buffer);
        if (bytesRead == -1) {
          socket.close();
          System.out.println("Closed " + socket);
          it.remove();
        }
        buffer.flip();
        for (int i = 0; i < buffer.limit(); i++) {
          buffer.put(i,
              (byte) Util.hokuspokus(buffer.get(i)));
        }
        while(buffer.hasRemaining()) {
          socket.write(buffer);
        }
      }
    }
  }
}
